    POSTSUPER(1)                                         POSTSUPER(1)

    NAME
           postsuper - Postfix superintendent

    SYNOPSIS
           postsuper [-psv] [-d queue_id] [-r queue_id] [directory
           ...]

    DESCRIPTION
           The postsuper command does maintenance jobs on the Postfix
           queue. Use of the command is restricted to the super-user.

           By default, postsuper performs  the  operations  requested
           with  the  -s  and  -p command-line options on all Postfix
           queue directories - this includes the incoming, active and
           deferred directories with mail files and the bounce, defer
           and flush directories with log files.

           Options:

           -d queue_id
                  Delete one message with the named queue ID from the
                  named  mail queue(s) (default: incoming, active and
                  deferred).  If a queue_id of -  is  specified,  the
                  program reads queue IDs from standard input.

                  Specify -d ALL to remove all messages; for example,
                  specify -d ALL  deferred  to  delete  mail  in  the
                  deferred  queue.  As a safety measure, the word ALL
                  must be specified in upper case.

                  Postfix queue IDs are  reused.   There  is  a  very
                  small  possibility that postsuper deletes the wrong
                  message file when it is executed while the  Postfix
                  mail system is running.

                  The scenario is as follows:

                  1)     The  Postfix  queue manager deletes the mes-
                         sage that postsuper is supposed  to  delete,
                         because  Postfix  is  finished with the mes-
                         sage.

                  2)     New mail arrives, and  the  new  message  is
                         given  the same queue ID as the message that
                         postsuper is supposed to delete.  The proba-
                         bility  for  reusing  a  deleted queue ID is
                         about 1 in 2**15 (the  number  of  different
                         microsecond values that the system clock can
                         distinguish within a second).

                  3)     postsuper deletes the new  message,  instead
                         of  the  old  message  that  it  should have
                         deleted.

           -p     Purge old temporary files that are left over  after
                  system or software crashes.

           -r queue_id
                  Requeue  the  message  with the named queue ID from
                  the named mail queue(s) (default: incoming,  active
                  and deferred).  To requeue multiple messages, spec-
                  ify multiple  -r  command-line  options.   Alterna-
                  tively,  if  a queue_id of - is specified, the pro-
                  gram reads queue IDs from standard input.

                  Specify -r ALL to requeue all messages. As a safety
                  measure,  the  word  ALL must be specified in upper
                  case.

                  A requeued message is moved to the maildrop  queue,
                  from  where  it is copied by the pickup daemon to a
                  new file whose name is guaranteed to match the  new
                  queue file inode number. The new queue file is sub-
                  jected again to mail address rewriting and  substi-
                  tution. This is useful when rewriting rules or vir-
                  tual mappings have changed.

                  Postfix queue IDs are  reused.   There  is  a  very
                  small possibility that postsuper requeues the wrong
                  message file when it is executed while the  Postfix
                  mail system is running, but no harm should be done.

           -s     Structure check and structure repair.  It is highly
                  recommended  to  perform this operation once before
                  Postfix startup.

                  o      Rename files whose name does not  match  the
                         message file inode number. This operation is
                         necessary after restoring a mail queue  from
                         a different machine, or from backup media.

                  o      Move queue files that are in the wrong place
                         in the file system hierarchy and remove sub-
                         directories that are no longer needed.  File
                         position rearrangements are necessary  after
                         a  change  in  the  hash_queue_names  and/or
                         hash_queue_depth configuration parameters.

           -v     Enable verbose logging for debugging purposes. Mul-
                  tiple  -v  options  make  the software increasingly
                  verbose.

    DIAGNOSTICS
           Problems are reported to the standard error stream and  to
           syslogd.

           postsuper  reports the number of messages deleted with -d,
           the number of messages requeued with -r, and the number of
           messages  whose  queue  file  name  was fixed with -s. The
           report is written to the standard error stream and to sys-
           logd.

    CONFIGURATION PARAMETERS
           See  the  Postfix  main.cf file for syntax details and for
           default values.

           hash_queue_depth
                  Number of subdirectory levels for hashed queues.

           hash_queue_names
                  The names of queues that are organized into  multi-
                  ple levels of subdirectories.

    LICENSE
           The  Secure  Mailer  license must be distributed with this
           software.

    AUTHOR(S)
           Wietse Venema
           IBM T.J. Watson Research
           P.O. Box 704
           Yorktown Heights, NY 10598, USA

                                                                    1